[PACKAGE]: ../../raw/master/mkp/vsphere_topo-0.0.9-20250116.mkp "vsphere_topo-0.0.9-20250116.mkp"
# vSphere Topology Visualization

This plugin uses the data from the _VMware ESX via vSphere_ special agent to create a topology of the vSphere environment.\
The topology contains the vCenter -> Data center(s) -> Clutser(s) -> VMs -> Datastore(s)\
It creates the topology on the fly with each check cycle. The plugin will also work in host only mode.

---
### Acknowledgements
ThX to [adadietrich](https://forum.checkmk.com/u/adadietrich/summary) for the idea and for being my beta tester

---
### Known issues

- The topology is only available on the site where the vCenter servier is monitored. There is no sync for topology files from reemote sites to the central site. As a workaround you could create a rsync job that copys the topology data to the main site.
- There is no direct access (link) to a specific topology, if use other topologies as well, you might need to select the right topology for display  via `Compare history` -> `Reference` -> `Compare to` on the topology screen.

---
### Download
* [Download latest mkp file][PACKAGE]

**Note**: before you update to a newer version, always check the [CHANGELOG](CHANGELOG). There migth be incompatible changes.\
**Note**: this plugin needs at least Checkmk 2.3.0b1 to work.   

---
### Installation

You can install the package by uploading it to your CheckMK site and as site user run 
```
mkp add PAKAGE_NAME.mkp
mkp enable PAKAGE_NAME VERSION
```

In the Enterprise/Free/Cloud edition of CheckMK you can use the GUI to install the package (_Setup_ -> _Extension Packages_ -> _Upload package_)

---
### Want to Contribute?

Nice ;-) Have a look at the [contribution guidelines](CONTRIBUTING.md "Contributing")

---
### Check Info

The plugin creates the service **_vSphere Topology_** on each discovered vCenter server (or ESXi host if in host only mode).

<details><summary>Montoring states</summary>

The service state is always ok.

</details>

<details><summary>Perfdata</summary>

| Metric | Unit | Perfometer |
| ------ | ------ | ------ |
| Time taken | s | yes |

</details>

---
### WATO
<details><summary>Service monitoring rule</summary>

| Section | Rule name |
| ------ | ------ |
| Applications, Processes & Services | vSphere Topology  |

| Option | Defailt value | Options |
| ------ | ------ |----|
| Adjust ESXi host names | none | |
| - Keep domain name | Disabled |  Enabled/Disabled |
| - Change case |no change | upper/lower/no change |
| - Name prefix | none | Prefix for host names |
| Adjust VM names | none | Same as Adjust ESXi host names only for VMs |
| vCenter icon | icon_topic_hosts | none, default, custom | 
| Cluster emblem | icon_plugins_hw | none, default, custom | 
| Datacenter emblem | icon_cloud | none, default, custom | 
| Datastore emblem | icon_services_green | none, default, custom | 
| Add data store service | Disabled | Enabled/Disabled |
| Make default | Disabled |  Enabled/Disabled |


</details> 

<details><summary>Discovery rule</summary>
There is no discovery rule.
</details> 

<details><summary>HW/SW inventory rules</summary>
There is no inventory rule.
</details> 

---
### Sample Output

Sample output

![sample output](img/sample.png?raw=true "sample output")

Sample vSphere topology

![sample output details](img/vsphere_topology.png?raw=true "sample vSphere topology")

